DOM::Attr Class Reference

`#include <dom_element.h>`

Inheritance diagram for DOM::Attr:

## Public Member Functions

| Attr (const Node &other)
| Attr (const Attr &other)
Attr & | operator= (const Node &other)
Attr & | operator= (const Attr &other)
DOMString | name () const
bool | specified () const
DOMString | value () const
void | setValue (const DOMString &)
Element | ownerElement () const
Public Member Functions inherited from DOM::Node
| Node (const Node &other)
| Node (NodeImpl *_impl)
Node & | operator= (const Node &other)
bool | operator== (const Node &other) const
bool | operator!= (const Node &other) const
DOMString | nodeName () const
DOMString | nodeValue () const
void | setNodeValue (const DOMString &)
unsigned short | nodeType () const
Node | parentNode () const
NodeList | childNodes () const
Node | firstChild () const
Node | lastChild () const
Node | previousSibling () const
Node | nextSibling () const
NamedNodeMap | attributes () const
Document | ownerDocument () const
Node | insertBefore (const Node &newChild, const Node &refChild)
Node | replaceChild (const Node &newChild, const Node &oldChild)
Node | removeChild (const Node &oldChild)
Node | appendChild (const Node &newChild)
bool | hasChildNodes ()
Node | cloneNode (bool deep)
void | normalize ()
bool | isSupported (const DOMString &feature, const DOMString &version) const
DOMString | namespaceURI () const
DOMString | prefix () const
void | setPrefix (const DOMString &prefix)
DOMString | localName () const
bool | hasAttributes ()
DOMString | textContent () const
void | setTextContent (const DOMString &content) const
void | addEventListener (const DOMString &type, EventListener *listener, const bool useCapture)
void | removeEventListener (const DOMString &type, EventListener *listener, bool useCapture)
bool | dispatchEvent (const Event &evt)
Q_UINT32 | elementId () const
bool | isNull () const
NodeImpl * | handle () const
unsigned long | index () const
QString | toHTML () KDE_DEPRECATED
void | applyChanges ()
void | getCursor (int offset, int &_x, int &_y, int &height) KDE_DEPRECATED
QRect | getRect ()

## Protected Member Functions

| Attr (AttrImpl *_impl)

## Friends

class | Element
class | Document
class | DocumentImpl
class | HTMLDocument
class | ElementImpl
class | NamedAttrMapImpl
class | AttrImpl

## Additional Inherited Members

Public Types inherited from DOM::Node
enum | NodeType { ELEMENT_NODE = 1, ATTRIBUTE_NODE = 2, TEXT_NODE = 3, CDATA_SECTION_NODE = 4, ENTITY_REFERENCE_NODE = 5, ENTITY_NODE = 6, PROCESSING_INSTRUCTION_NODE = 7, COMMENT_NODE = 8, DOCUMENT_NODE = 9, DOCUMENT_TYPE_NODE = 10, DOCUMENT_FRAGMENT_NODE = 11, NOTATION_NODE = 12 }
Protected Attributes inherited from DOM::Node
NodeImpl * | impl

## Detailed Description

The `Attr` interface represents an attribute in an `Element` object.

Typically the allowable values for the attribute are defined in a document type definition.

`Attr` objects inherit the `Node` interface, but since they are not actually child nodes of the element they describe, the DOM does not consider them part of the document tree. Thus, the `Node` attributes `parentNode` , `previousSibling` , and `nextSibling` have a null value for `Attr` objects. The DOM takes the view that attributes are properties of elements rather than having a separate identity from the elements they are associated with; this should make it more efficient to implement such features as default attributes associated with all elements of a given type. Furthermore, `Attr` nodes may not be immediate children of a `DocumentFragment` . However, they can be associated with `Element` nodes contained within a `DocumentFragment` . In short, users and implementors of the DOM need to be aware that `Attr` nodes have some things in common with other objects inheriting the `Node` interface, but they also are quite distinct.

The attribute's effective value is determined as follows: if this attribute has been explicitly assigned any value, that value is the attribute's effective value; otherwise, if there is a declaration for this attribute, and that declaration includes a default value, then that default value is the attribute's effective value; otherwise, the attribute does not exist on this element in the structure model until it has been explicitly added. Note that the `nodeValue` attribute on the `Attr` instance can also be used to retrieve the string version of the attribute's value(s).

In XML, where the value of an attribute can contain entity references, the child nodes of the `Attr` node provide a representation in which entity references are not expanded. These child nodes may be either `Text` or `EntityReference` nodes. Because the attribute type may be unknown, there are no tokenized attribute values.

Definition at line 89 of file dom_element.h.

## Member Function Documentation

DOMString Attr::name | ( |  | ) | const

Returns the name of this attribute.

Definition at line 68 of file dom_element.cpp.

Element Attr::ownerElement | ( |  | ) | const

Introduced in DOM Level 2.

The Element node this attribute is attached to or null if this attribute is not in use.

Definition at line 80 of file dom_element.cpp.

void Attr::setValue | ( | const DOMString & | newValue | ) |

see value

Definition at line 92 of file dom_element.cpp.

bool Attr::specified | ( |  | ) | const

If this attribute was explicitly given a value in the original document, this is `true` ; otherwise, it is `false` .

Note that the implementation is in charge of this attribute, not the user. If the user changes the value of the attribute (even if it ends up having the same value as the default value) then the `specified` flag is automatically flipped to `true` . To re-specify the attribute as the default value from the DTD, the user must delete the attribute. The implementation will then make a new attribute available with `specified` set to `false` and the default value (if one exists).

In summary:

- If the attribute has an assigned value in the document then `specified` is `true` , and the value is the assigned value.

- If the attribute has no assigned value in the document and has a default value in the DTD, then `specified` is `false` , and the value is the default value in the DTD.

- If the attribute has no assigned value in the document and has a value of #IMPLIED in the DTD, then the attribute does not appear in the structure model of the document.

Definition at line 74 of file dom_element.cpp.

DOMString Attr::value | ( |  | ) | const

On retrieval, the value of the attribute is returned as a string.

Character and general entity references are replaced with their values.

On setting, this creates a `Text` node with the unparsed contents of the string.

Definition at line 86 of file dom_element.cpp.

The documentation for this class was generated from the following files:

- dom_element.h
- dom_element.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys